const tmi = require('tmi.js');
require('dotenv').config();

console.log(process.env.API_HOST);

const client = new tmi.Client({
  options: { debug: true },
  connection: {
    secure: true,
    reconnect: true
  },
  identity: {
    username: process.env.TTV_BOT_USERNAME,
    password: process.env.TTV_BOT_OAUTH
  },
  channels: [ process.env.TTV_CHANNELS ]
});

client.connect();

client.on('message', (channel, tags, message, self) => {
    if(self) return;
    const badges = tags.badges || {};
    const isBroadcaster = badges.broadcaster;
    const isMod = badges.moderator;
    const isModUp = isBroadcaster || isMod;
});

// TODO:
// + Add Cooldowns
// + Add Mod vs Streamer vs Viewer vs Sub control
// + Turn BOTO into join userchannel_db & make botoff to rm_userchannel_db
// + Timed
// + B-Day Calc
// +
// + 

client.on('message', (channel, tags, message, self) => {
  if(self || !message.startsWith('!')) return;

  const args = message.slice(1).split(' ');
  const command = args.shift().toLowerCase();

  const botUserState = client.userstate[channel];
  const amMod = botUserState !== undefined && botUserState.mod === true;

  // B E T A
  // ==================================
  // The Boto
  // ----------------------------------
  if(command === 'boto' || command === 'sariboto' || command === 'sari-boto') {
    client.say(channel, `/me Bleep! Bloop! Twitch IRC connected... LETS PARTY!!!`);
    client.say(channel, `!kappagen imGlitch EarthDay imGlitch EarthDay imGlitch`);
  }
  // The Echo
  // ----------------------------------
  else if(command === 'echo') {
    client.say(channel, `/me Off in the distance @${tags.username} screams...`);
    client.say(channel, `" ${args.join(' ')} ${args.join(' ')} ${args.join(' ')} ${args.join(' ')} ${args.join(' ')} " can be heard to all those around!`);
  }

  // T H E   S H O W
  // ==================================
  // Being Raided
  // ----------------------------------
  else if(command === 'raid' || command === 'raided') {
    client.say(channel, `!kappagen sarimoRAID sarimoFREEDOM sarimoRAID sarimoFREEDOM sarimoRAID sarimoFREEDOM`);
    client.say(channel, `/me Did @${tags.username} say RAID!?! I believe ${args.join(' ')}, was mentioned as well!`);
  }
  // Raiding Someone
  // ----------------------------------
  else if(command === 'raidcall' || command === 'spam' || command === 'spamwars') {
    client.say(channel, `!kappagen sarimoRAID sarimoFREEDOM sarimoRAID sarimoFREEDOM sarimoRAID sarimoFREEDOM`);
    client.say(channel, `/me Thanks everyone for watching!!! PREPARE TO SPAM!`);
    client.say(channel, `/me Copy'n'Paste the following:`);
    client.say(channel, `sarimoRAID sarimoFREEDOM You may take us viewers, but you'll NEVER take our FREEDOM!`);
  }

  // K A P P A
  // ==================================
  // FX | Hi
  // ----------------------------------
  else if(command === 'hi' || command === 'hello' || command === 'welcome' || command === 'greeting' || command === 'greetings') {
    client.say(channel, `!kappagen HeyGuys bleedPurple HeyGuys bleedPurple HeyGuys`);
    client.say(channel, `/me Hi Hello Howdy Hola こんにちは Oi 你好 여보세요 Здравствуйте Bonjour Hej Hiya Heyo Yo`);
  }
  // FX | Hi
  // ----------------------------------
  else if(command === 'sup' || command === 'whatsup' || command === 'sups' || command === 'wazzup' || command === 'soup' || command === 'soups') {
    client.say(channel, `!kappagen sarimoTRIP sarimoSOUP sarimoTRIP sarimoSOUP sarimoTRIP sarimoSOUP `);
    client.say(channel, `/me Yo @${tags.username}, how goes it?`);
  }

  // FX | Salt
  // ----------------------------------
  else if(command === 'salt' || command === 'yoho' || command === 'rage' || command === 'rip' || command === 'sassy' || command === 'salty' || command === 'bitter') {
    client.say(channel, `!kappagen PJSalt PanicVis PJSalt WutFace PJSalt PunOko PJSalt BabyRage PJSalt`);
  }

  
  // G E N E R A L
  // ==================================
  // Uptime
  // ----------------------------------
  // if(commandName === 'uptime') {
  //  let timestamp = new Date(body.stream.created_at).getTime();
  //  uptime = countdown(timestamp, Date.now(), 158);
  //  reply(uptime);
  //}

  // The 2Pac Timezone
  // ----------------------------------
  else if(command === '2pac' || command === 'pst' || command === 'timezone') {
    client.say(channel, `/me Off in the distance @${tags.username} screams...`);
    client.say(channel, `" ${args.join(' ')} ${args.join(' ')} ${args.join(' ')} ${args.join(' ')} ${args.join(' ')} " can be heard to all those around!`);
  }

  

  

  
  // E R R O R S
  // ==================================
  // NOT FOUND FUNCTION
  else {
    client.say(channel, `/me Bleep! Bloop! Error! Sorry, @${tags.username} hopefully SE/SL/Nitebot has ya covered...`);
  }
});
